﻿using System;
using System.Windows.Controls;
using System.Collections.Generic;

using Sandworks.Silverlight.UI.Scroll;

namespace Sandworks.Silverlight.ScrollDataGridExample
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            InitializePage();
        }

        private void InitializePage()
        {
            // Update textblocks when scrolling.
            dg.VerticalScroll += (s, e) => { tbVertical.Text = (int)e.NewValue + " / " + dg.GetScrollMaximum(ScrollMode.Vertical); };
            dg.HorizontalScroll += (s, e) => { tbHorizontal.Text = (int)e.NewValue + " / " + dg.GetScrollMaximum(ScrollMode.Horizontal); };
            
            // Bind modes.
            List<ScrollMode> modes = new List<ScrollMode>();
            modes.Add(ScrollMode.Vertical);
            modes.Add(ScrollMode.Horizontal);
            comboMode.ItemsSource = modes;
            comboMode.SelectedItem = ScrollMode.Vertical;

            // Bind people.           
            List<Person> people = new List<Person>(); 
            Random rnd = new Random();
            for (int i = 0; i < 1000; i++)
            {
                Person p = new Person();
                p.Address = "Somestreet, nr. " + rnd.Next(1, 10000);
                p.Name = "Person, id: " + (i * rnd.Next(1, 10000) - (i * 10));
                p.Age = rnd.Next(1, 100);
                people.Add(p);
            }
            dg.ItemsSource = people;
        }

        private void OnGoToStart(object sender, System.Windows.RoutedEventArgs e)
        {
            ScrollMode mode = (ScrollMode)comboMode.SelectedItem;
            dg.ScrollToStart(mode);
        }

        private void OnGoToEnd(object sender, System.Windows.RoutedEventArgs e)
        {
            ScrollMode mode = (ScrollMode)comboMode.SelectedItem;
            dg.ScrollToEnd(mode);
        }

        private void OnReloadPosition(object sender, System.Windows.RoutedEventArgs e)
        {
            ScrollMode mode = (ScrollMode)comboMode.SelectedItem;
            dg.ReloadScrollPosition(mode);
        }

        private void OnSavePosition(object sender, System.Windows.RoutedEventArgs e)
        {
            ScrollMode mode = (ScrollMode)comboMode.SelectedItem;
            dg.SaveScrollPosition(mode);
        }
    }
}
